/**
 * @fileOverview jui_pagination: jQuery plugin, provides pagination using page links or jQuery UI slider. Fully configurable. jQuery UI themes compatible. Localization support.
 *               <p>License MIT
 *               <br />Copyright Christos Pontikis <a href="http://pontikis.net">http://pontikis.net</a>
 *               <br />Project page <a href="http://pontikis.net/labs/jui_pagination">http://pontikis.net/labs/jui_pagination</a>
 *               <br />Minified using Online YUI Compressor http://www.refresh-sf.com/yui/
 * @version 2.0.0 (22 Jan 2013)
 * @author Christos Pontikis http://pontikis.net
 * @requires jquery >= 1.6, jquery-ui >= 1.8
 */
"use strict";(function(g){var j="jui_pagination";var d={init:function(k){var l=this;return this.each(function(){var ax=l.data(j);if(typeof(ax)=="undefined"){var ac=l.jui_pagination("getDefaults");ax=g.extend({},ac,k)}else{ax=g.extend({},ax,k)}l.data(j,ax);var W=l.attr("id");b(W);if(l.data("error_occured")){l.html("");l.data("error_occured",false)}l.unbind("onChangePage").bind("onChangePage",ax.onChangePage);l.unbind("onSetRowsPerPage").bind("onSetRowsPerPage",ax.onSetRowsPerPage);l.unbind("onDisplay").bind("onDisplay",ax.onDisplay);var E=ax.totalPages;var D=ax.currentPage;var T=ax.visiblePageLinks;var Z=ax.rowsPerPage;var ai=ax.useSlider;var F=ax.sliderElementID;var ap=ax.useSliderWithPagesCount;var K=ax.sliderOrientation;var ah=ax.sliderAnimation;var L=ax.sliderInsidePane;var at=ax.showGoToPage;var an=ax.showNavButtons;var ag=ax.showLabelCurrentPage;var M=ax.showCurrentPage;var A=ax.showNavPages;var aq=ax.navPagesMode;var aw=ax.showLabelTotalPages;var y=ax.showTotalPages;var am=ax.showRowsPerPage;var X=ax.showRowsInfo;var af=ax.showPreferences;var H=ax.nav_pane_display_order;var Y=ax.containerClass;var C=ax.navPaneClass;var S=ax.navGoToPageClass;var n=ax.navButtonTopClass;var r=ax.navButtonPrevClass;var V=ax.navCurrentPageLabelClass;var aa=ax.navCurrentPageClass;var U=ax.navPagesClass;var x=ax.navTotalPagesLabelClass;var al=ax.navTotalPagesClass;var z=ax.navButtonNextClass;var m=ax.navButtonLastClass;var p=ax.navRowsPerPageClass;var P=ax.navInfoClass;var az=ax.preferencesClass;var J=(ax.sliderInsidePane?ax.sliderInsidePaneClass:ax.sliderClass);var G=e(ax.nav_pane_id_prefix,W);var s=e(ax.nav_goto_page_id_prefix,W);var O=e(ax.nav_current_page_label_id_prefix,W);var ay=e(ax.nav_current_page_id_prefix,W);var ao=e(ax.nav_top_id_prefix,W);var R=e(ax.nav_prev_id_prefix,W);var o=e(ax.nav_pages_id_prefix,W);var I=e(ax.nav_item_id_prefix,W)+"_";var ak=e(ax.nav_next_id_prefix,W);var q=e(ax.nav_last_id_prefix,W);var ar=e(ax.nav_total_pages_label_id_prefix,W);var ae=e(ax.nav_total_pages_id_prefix,W);var B=e(ax.nav_rows_per_page_id_prefix,W);var N=e(ax.nav_rows_info_id_prefix,W);var ab=e(ax.preferences_id_prefix,W);var ad=e(ax.pref_dialog_id_prefix,W);var w=(!F?e(ax.slider_id_prefix,W):F);var aA=ax.disableSelectionNavPane;var aj;var Q;var v;if(ai){var av=(ap==0?T:Math.max(ap,T));if(E<=av){ai=false}}if(Y!=""){l.removeClass().addClass(Y)}if(g("#"+G).length==0){l.html('<div id="'+G+'"></div>'+l.html())}aj=g("#"+G);var au="";if(af){au+='<div id="'+ab+'" title="'+rsc_jui_pag.preferences_title+'">'+rsc_jui_pag.preferences_text+"</div>"}g.each(H,function(aB,aC){if(aC=="go_to_page"){if(at){au+='<input type="text" id="'+s+'" title="'+rsc_jui_pag.go_to_page_title+'">'}}else{if(aC=="slider"){if(ai&&L){Q=g("#"+w);if(typeof(Q.data("slider"))=="object"||typeof(Q.data("uiSlider"))=="object"){Q.slider("destroy");Q.html("")}au+='<div id="'+w+'"></div>'}}else{if(aC=="back_buttons"){if(an){au+='<div id="'+ao+'">'+rsc_jui_pag.go_top_text+"</div>";au+='<div id="'+R+'">'+rsc_jui_pag.go_prev_text+"</div>"}}else{if(aC=="current_page_label"){if(ag){au+='<div id="'+O+'">'+rsc_jui_pag.current_page_label+"</div>"}}else{if(aC=="current_page"){if(M){au+='<div id="'+ay+'">'+D+"</div>"}}else{if(aC=="nav_items"){if(A){au+='<div id="'+o+'"></div>'}}else{if(aC=="total_pages_label"){if(aw){au+='<div id="'+ar+'">'+rsc_jui_pag.total_pages_label+"</div>"}}else{if(aC=="total_pages"){if(y){au+='<div id="'+ae+'">'+E+"</div>"}}else{if(aC=="forward_buttons"){if(an){au+='<div id="'+ak+'">'+rsc_jui_pag.go_next_text+"</div>";au+='<div id="'+q+'">'+rsc_jui_pag.go_last_text+"</div>"}}else{if(aC=="rows_per_page"){if(am){au+='<input type="text" id="'+B+'" value="'+Z+'" title="'+rsc_jui_pag.rows_per_page_title+'">'}}else{if(aC=="rows_info"){if(X){au+='<div id="'+N+'"></div>'}}}}}}}}}}}}});aj.html(au);aj.removeClass().addClass(C);g("#"+s).removeClass().addClass(S);g("#"+O).removeClass().addClass(V);g("#"+ay).removeClass().addClass(aa);g("#"+ao).removeClass().addClass(n);g("#"+R).removeClass().addClass(r);g("#"+o).removeClass().addClass(U);g("#"+ak).removeClass().addClass(z);g("#"+q).removeClass().addClass(m);g("#"+ar).removeClass().addClass(x);g("#"+ae).removeClass().addClass(al);g("#"+B).removeClass().addClass(p);g("#"+N).removeClass().addClass(P);g("#"+ab).removeClass().addClass(az);i(W);if(an){v="#"+ao;aj.off("click",v).on("click",v,function(){ax.currentPage=1;f(W,ax.currentPage,true,true)});v="#"+R;aj.off("click",v).on("click",v,function(){if(ax.currentPage>1){ax.currentPage=parseInt(ax.currentPage)-1;f(W,ax.currentPage,true,true)}});v="#"+ak;aj.off("click",v).on("click",v,function(){if(ax.currentPage<ax.totalPages){ax.currentPage=parseInt(ax.currentPage)+1;f(W,ax.currentPage,true,true)}});v="#"+q;aj.off("click",v).on("click",v,function(){ax.currentPage=parseInt(ax.totalPages);f(W,ax.currentPage,true,true)})}v='[id^="'+I+'"]';aj.off("click",v).on("click",v,function(aC){var aB=I.length;ax.currentPage=parseInt(g(aC.target).attr("id").substr(aB));if(aq=="continuous"){f(W,ax.currentPage,false,true)}else{if(aq=="first-last-always-visible"){f(W,ax.currentPage,true,true)}}});if(at){v="#"+s;aj.off("keypress",v).on("keypress",v,function(aC){if(aC.which===13){var aB=parseInt(g(aC.target).val());g("#"+s).val("");if(!isNaN(aB)&&aB>0){ax.currentPage=aB;if(ax.currentPage>ax.totalPages){ax.currentPage=ax.totalPages}f(W,ax.currentPage,true,true)}else{l.triggerHandler("onChangePage",ax.currentPage)}aC.preventDefault()}else{if(!(aC.which===8||aC.which===0||(aC.shiftKey===false&&(aC.which>47&&aC.which<58)))){aC.preventDefault()}}})}if(am){v="#"+B;aj.off("keypress",v).on("keypress",v,function(aB){if(aB.which===13){var aC=parseInt(g(aB.target).val());if(!isNaN(aC)&&aC>0){ax.rowsPerPage=aC}else{g("#"+B).val(ax.rowsPerPage)}l.triggerHandler("onSetRowsPerPage",aC);aB.preventDefault()}else{if(!(aB.which===8||aB.which===0||(aB.shiftKey===false&&(aB.which>47&&aB.which<58)))){aB.preventDefault()}}})}if(aA){c(aj)}if(ai){if(!F&&!L){if(g("#"+w).length==0){l.append('<div id="'+w+'"></div>')}}Q=g("#"+w);if(F){v="#"+e(ax.slider_id_prefix,W);if(typeof(g(v).data("slider"))=="object"||typeof(g(v).data("uiSlider"))=="object"){g(v).slider("destroy");g(v).html("")}}Q.removeClass(J).addClass(J);Q.slider({min:1,max:E,value:(K=="horizontal"?D:E-D+1),animate:ah,range:(K=="horizontal"?"min":"max"),orientation:K,stop:function(aB,aC){ax.currentPage=(K=="horizontal"?parseInt(aC.value):parseInt(E)-parseInt(aC.value)+1);f(W,ax.currentPage,true,false)}})}else{Q=g("#"+w);if(typeof(Q.data("slider"))=="object"||typeof(Q.data("uiSlider"))=="object"){Q.slider("destroy");Q.html("")}}if(af){if(g("#"+ad).length==0){var u='<div id="'+ad+'"></div>';l.append(u)}v="#"+ab;var t=g("#"+ad);aj.off("click",v).on("click",v,function(){if(typeof(t.data("dialog"))=="object"){t.dialog("destroy")}t.dialog({autoOpen:true,position:{my:"top",at:"bottom",of:"#"+W},title:rsc_jui_pag.preferences_title,buttons:[{text:rsc_jui_pag.preferences_close,click:function(){g(this).dialog("close")}}],open:h(W)})});v="#"+ad+"_slider";t.off("click",v).on("click",v,function(aB){var aC=g(aB.target).is(":checked");l.jui_pagination({useSlider:aC})});v="#"+ad+"_goto_page";t.off("click",v).on("click",v,function(aB){var aC=g(aB.target).is(":checked");l.jui_pagination({showGoToPage:aC})});v="#"+ad+"_rows_per_page";t.off("click",v).on("click",v,function(aB){var aC=g(aB.target).is(":checked");l.jui_pagination({showRowsPerPage:aC})});v="#"+ad+"_rows_info";t.off("click",v).on("click",v,function(aB){var aC=g(aB.target).is(":checked");l.jui_pagination({showRowsInfo:aC})});v="#"+ad+"_nav_buttons";t.off("click",v).on("click",v,function(aB){var aC=g(aB.target).is(":checked");l.jui_pagination({showNavButtons:aC})})}l.triggerHandler("onDisplay")})},getDefaults:function(){return{currentPage:1,visiblePageLinks:5,maxVisiblePageLinks:20,rowsPerPage:10,nav_pane_display_order:["slider","go_to_page","back_buttons","current_page_label","current_page","nav_items","total_pages_label","total_pages","forward_buttons","rows_per_page","rows_info"],useSlider:false,sliderInsidePane:true,sliderElementID:false,useSliderWithPagesCount:0,sliderOrientation:"horizontal",sliderAnimation:"slow",showGoToPage:false,showNavButtons:false,showLabelCurrentPage:true,showCurrentPage:false,showNavPages:true,navPagesMode:"first-last-always-visible",showLabelTotalPages:false,showTotalPages:false,showRowsPerPage:false,showRowsInfo:false,showPreferences:true,navPaneClass:"nav-pane ui-state-default ui-corner-all",navGoToPageClass:"goto-page ui-state-default ui-corner-all",navButtonTopClass:"nav-button-top ui-icon ui-icon-seek-first",navButtonPrevClass:"nav-button-prev ui-icon ui-icon-seek-prev",navCurrentPageLabelClass:"current-page-label",navCurrentPageClass:"current-page",navDotsLeftClass:"nav-dots-left",navPagesClass:"nav-pages",navItemClass:"nav-item ui-state-default ui-corner-all",navItemSelectedClass:"nav-item ui-state-default ui-corner-all ui-state-highlight",navItemHoverClass:"ui-state-hover",navDotsRightClass:"nav-dots-right",navTotalPagesLabelClass:"total-pages-label",navTotalPagesClass:"total-pages",navButtonNextClass:"nav-button-next  ui-icon ui-icon-seek-next",navButtonLastClass:"nav-button-last  ui-icon ui-icon-seek-end",navRowsPerPageClass:"rows-per-page  ui-state-default ui-corner-all",navInfoClass:"rows-info",sliderClass:"nav-slider",sliderInsidePaneClass:"nav-slider-inside-pane",preferencesClass:"preferences ui-icon ui-icon-signal",nav_pane_id_prefix:"nav_pane_",nav_goto_page_id_prefix:"goto_page_",nav_current_page_label_id_prefix:"current_page_lbl_",nav_current_page_id_prefix:"current_page_",nav_top_id_prefix:"top_",nav_prev_id_prefix:"prev_",nav_dots_left_id_prefix:"dots_left_",nav_pages_id_prefix:"pages_",nav_item_id_prefix:"page_",nav_dots_right_id_prefix:"dots_right_",nav_next_id_prefix:"next_",nav_last_id_prefix:"last_",nav_total_pages_label_id_prefix:"total_pages_lbl_",nav_total_pages_id_prefix:"total_pages_",nav_rows_per_page_id_prefix:"rows_per_page_",nav_rows_info_id_prefix:"rows_info_",slider_id_prefix:"sld_",preferences_id_prefix:"pref_",pref_dialog_id_prefix:"pref_dlg_",disableSelectionNavPane:false,onChangePage:function(){},onSetRowsPerPage:function(){},onDisplay:function(){}}},getOption:function(k){var l=this;return l.data(j)[k]},getAllOptions:function(){var k=this;return k.data(j)},setOption:function(k,n,m){var l=this;l.data(j)[k]=n;if(m){l.jui_pagination("init")}},destroy:function(){return g(this).each(function(){var k=g(this);k.removeData(j)})},setRowsInfo:function(k){var l=this;var m=e(l.jui_pagination("getOption","nav_rows_info_id_prefix"),g(this).attr("id"));g("#"+m).html(k)}};var e=function(l,k){return l+k};var c=function(k){return k.attr("unselectable","on").css("user-select","none").on("selectstart",false)};var b=function(n){var q;var m=g("#"+n);var l=m.jui_pagination("getOption","totalPages");if(parseInt(l)<=0||isNaN(parseInt(l))){q="Invalid totalPages";m.html('<span style="color: red;">ERROR: '+q+"</span>");m.data("error_occured",true);g.error(q)}var k=m.jui_pagination("getOption","currentPage");if(parseInt(k)<=0||isNaN(parseInt(k))){q="Invalid currentPage";m.html('<span style="color: red;">ERROR: '+q+"</span>");m.data("error_occured",true);g.error(q)}var p=m.jui_pagination("getOption","visiblePageLinks");if(parseInt(p)<=0||isNaN(parseInt(p))){q="Invalid visiblePageLinks";m.html('<span style="color: red;">ERROR: '+q+"</span>");m.data("error_occured",true);g.error(q)}if(parseInt(k)>parseInt(l)){q="Invalid currentPage > totalPages";m.html('<span style="color: red;">ERROR: '+q+"</span>");m.data("error_occured",true);g.error(q)}var o=m.jui_pagination("getOption","maxVisiblePageLinks");if(parseInt(p)>parseInt(o)){q="Invalid visiblePageLinks > maxVisiblePageLinks";m.html('<span style="color: red;">ERROR: '+q+"</span>");m.data("error_occured",true);g.error(q)}};var h=function(t){var n=g("#"+t);var r=n.jui_pagination("getOption","pref_dialog_id_prefix");var p=e(r,t);var l;var m;var o="";o+='<ul style="list-style-type: none;">';l=p+"_slider";o+="<li>";o+='<input type="checkbox" id="'+l+'" /><label for="'+l+'">'+rsc_jui_pag.pref_show_slider+"</label>";o+="</li>";l=p+"_goto_page";o+="<li>";o+='<input type="checkbox" id="'+l+'" /><label for="'+l+'">'+rsc_jui_pag.pref_show_goto_page+"</label>";o+="</li>";l=p+"_rows_per_page";o+="<li>";o+='<input type="checkbox" id="'+l+'" /><label for="'+l+'">'+rsc_jui_pag.pref_show_rows_per_page+"</label>";o+="</li>";l=p+"_rows_info";o+="<li>";o+='<input type="checkbox" id="'+l+'" /><label for="'+l+'">'+rsc_jui_pag.pref_show_rows_info+"</label>";o+="</li>";l=p+"_nav_buttons";o+="<li>";o+='<input type="checkbox" id="'+l+'" /><label for="'+l+'">'+rsc_jui_pag.pref_show_nav_buttons+"</label>";o+="</li>";o+="</ul>";g("#"+p).html(o);var k=["_slider","_goto_page","_rows_per_page","_rows_info","_nav_buttons"];var s=["useSlider","showGoToPage","showRowsPerPage","showRowsInfo","showNavButtons"];for(var q in k){l=p+k[q];m=n.jui_pagination("getOption",s[q]);g("#"+l).attr("checked",m)}};var i=function(H){var T=g("#"+H);var P=g(T).jui_pagination("getAllOptions");var Q=P.navPagesMode;var w=P.totalPages;var u=P.currentPage;var G=P.visiblePageLinks;var r=P.showNavPages;var N=P.showNavButtons;var S=P.navItemClass;var J=P.navItemSelectedClass;var v=P.navItemHoverClass;var I=P.navDotsLeftClass;var q=P.navDotsRightClass;var O=e(P.nav_top_id_prefix,H);var E=e(P.nav_prev_id_prefix,H);var B=e(P.nav_dots_left_id_prefix,H);var k=e(P.nav_pages_id_prefix,H);var A=e(P.nav_item_id_prefix,H)+"_";var F=e(P.nav_dots_right_id_prefix,H);var M=e(P.nav_next_id_prefix,H);var l=e(P.nav_last_id_prefix,H);var n="";var U;var z="";var t=parseInt(u);var W=g("#"+k);if(Q=="continuous"){var x,C,m,L,p;x=t;if(w<G){x=1;C=w}else{p=Math.ceil(w/G);if(x>G*(p-1)){x=w-G+1}else{m=x%G;if(m==0){L=-G+1}else{L=-m+1}x+=L}C=x+G-1}T.data("nav_start",x);T.data("nav_end",C);if(N){var R=(r?x:t);n="#"+O+", #"+E;if(R>1){g(n).show()}else{g(n).hide()}R=(r?C:t);n="#"+M+", #"+l;if(R<w){g(n).show()}else{g(n).hide()}}if(x>1){z+='<div id="'+B+'">...</div>'}for(U=x;U<=C;U++){z+='<div id="'+A+U+'">'+U+"</div>"}if(C<w){z+='<div id="'+F+'">...</div>'}W.html(z)}else{if(Q=="first-last-always-visible"){if(w<=5){for(U=1;U<=w;U++){z+='<div id="'+A+U+'">'+U+"</div>"}}else{var o=G;if(o<5){o=5}if(o>w){o=w}var V=o-2;var D=Math.floor((V-1)/2);var K=Math.ceil((V-1)/2);if(t<=V){for(U=1;U<=V+1;U++){z+='<div id="'+A+U+'">'+U+"</div>"}z+='<div id="'+F+'">...</div>';z+='<div id="'+A+w+'">'+w+"</div>"}else{if(t>w-V){z+='<div id="'+A+'1">1</div>';z+='<div id="'+B+'">...</div>';for(U=w-V;U<=w;U++){z+='<div id="'+A+U+'">'+U+"</div>"}}else{z+='<div id="'+A+'1">1</div>';z+='<div id="'+B+'">...</div>';for(U=t-D;U<=t+K;U++){z+='<div id="'+A+U+'">'+U+"</div>"}z+='<div id="'+F+'">...</div>';z+='<div id="'+A+w+'">'+w+"</div>"}}}W.html(z);if(N){n="#"+O+", #"+E;if(t>1){g(n).show()}else{g(n).hide()}n="#"+M+", #"+l;if(t<w){g(n).show()}else{g(n).hide()}}}}g("#"+B).removeClass().addClass(I);g("#"+F).removeClass().addClass(q);var y=g('[id^="'+A+'"]');y.removeClass().addClass(S);g("#"+A+t).removeClass().addClass(J);if(v!=""){y.hover(function(){g(this).addClass(v)},function(){g(this).removeClass(v)})}};var a=function(p,y,q){var n=g("#"+p);var z=g(n).jui_pagination("getAllOptions");var v=z.totalPages;var r=z.showCurrentPage;var o=z.sliderElementID;var m=(!o?e(z.slider_id_prefix,p):o);var k=z.sliderOrientation;var w=e(z.nav_current_page_id_prefix,p);var t=e(z.nav_item_id_prefix,p)+"_";var u=z.navItemClass;var l=z.navItemSelectedClass;g('[id^="'+t+'"]').removeClass().addClass(u);g("#"+t+y).removeClass().addClass(l);if(r){g("#"+w).text(y)}if(q){var x=g("#"+m);if(typeof(x.data("slider"))=="object"||typeof(x.data("uiSlider"))=="object"){x.slider({value:(k=="horizontal"?y:v-y+1)})}}n.triggerHandler("onChangePage",y)};var f=function(n,k,m,l){if(m){i(n)}a(n,k,l)};g.fn.jui_pagination=function(l){if(this.size()!=1){var k="You must use this plugin ("+j+") with a unique element (at once)";this.html('<span style="color: red;">ERROR: '+k+"</span>");g.error(k)}if(d[l]){return d[l].apply(this,Array.prototype.slice.call(arguments,1))}else{if(typeof l==="object"||!l){return d.init.apply(this,arguments)}else{g.error("Method "+l+" does not exist on jQuery."+j)}}}})(jQuery);